import 'dart:async';
import 'dart:convert';
import 'package:flutter/material.dart';
import '../models/category.dart';
import 'package:http/http.dart' as http;

void main() => runApp(new HomePage());

class HomePage extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        title: 'JSON Advanced',
        theme: ThemeData(primarySwatch: Colors.teal),
        home: Scaffold(
          appBar: AppBar(title: Text('JSON Advanced')),
          body: Center(
            child: FutureBuilder<List<Category>>(
                future: fetchListCategory(),
                builder: (context, snapshot) {
                  if(snapshot.hasError){
                    return Text('yes: ' + '${snapshot.error}');
                  } else {
                    return Text('no');
                  }

                  // if (
                  //     snapshot.hasData) {
                  //     print('project snapshot data is: ${snapshot.data}');
                  //   return Container(child: Text('hello1'));
                  // } else {
                  //   return Container(child: Text('hello'),);
                  // }

                  // if(snapshot.hasData){
                  //   List<Category> categories = snapshot.data;
                  //   return ListView(
                  //     children:
                  //     categories.map((category)=> Text('Category: ')).toList(),
                  //   );
                  // } else if (snapshot.hasError) {
                  //   return Text('${snapshot.error}' + 'there is an error');
                  // } else {
                  //   return Text('there is no data');
                  // }
                }),
          ),
        ));
  }
}

Future<List<Category>> fetchListCategory() async {
  //print('Going to load interests');
  final response =
      await http.get('https://finditgranada.com/wp-json/wp/v2/listing-type');

  if (response.statusCode == 200) {
    List categories = json.decode(response.body);
    print(categories);
    return categories.map((category) => new Category.fromJson(category)).toList();
  } else {
    throw Exception('Failed to load Categories');
  }
}
